#include <iostream>

using namespace std;

int main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n, m, q, suma=0, suma1=0;
    cin>>n>>m;
    int doha[n] [m];
    for(int i=0; i<n; i++)
    {
        for(int j=0; j<m; j++)
        {
            cin>>doha[i][j];
        }
    }
    cin>>q;
    int x[q], y[q];
    for(int w=0; w<q; w++)
    {
        cin>>x[w]>>y[w];
    }
    for(int i=0; i<q; i++)
    {
        if(x[i]==1)
        {
            for(int j=0; j<m; j++)
            {
                suma+=doha[1][j];
            }
            suma+=doha[0][0];
            for(int k=1; k<y[i]; k++)
            {
                suma1=0;
                for(int r=0; r<k; r++)
                {
                    suma1+=doha[0][r];
                }
                for(int j=k-1; j<m; j++)
                {
                    suma1+=doha[1][j];
                }
                if(suma1<suma)
                {
                    suma=suma1;
                }

            }


        }
    }
    cout<<suma;

    return 0;
}